from adap_gl import AdapGL as agl
import math
from calcroot import Newton

class NormalDistri:
    def __init__(self):
        self.c = 1.0 / math.sqrt(2.0 * math.pi)

    def v(self, z):
        return self.c * math.exp(-0.5 * z * z)

n_func = NormalDistri()

gl = agl()

def cum_normal( z ):
    if z > 0.0:
        return 0.5 + gl.integral(0.0, z, n_func)
    elif z < 0.0:
        return 0.5 - gl.integral(z, 0.0, n_func)
    else:
        return 0.5

class Ccum_normal:
    def __init__(self):
        pass

    def v(self, z):
        return cum_normal(z)

f_cum_n = Ccum_normal()

class DFunc_normal:
    def __init__(self):
        pass

    def v(self, z):
        return n_func.v(z)

df_cum_n = DFunc_normal()
    

def calc_z( p ):
    Lz = 0.0
    while (f_cum_n.v(Lz) >= p):
        Lz -= 1.0
    Uz = Lz + 1.0
    while (f_cum_n.v(Uz) <= p):
        Uz += 1.0
    z = Newton( f_cum_n, df_cum_n, p, Lz, Uz )
    return z

while True:
    try:
        s = input("p = ")
        p = float(s)
        if ((p <= 0.0) or (p >= 1.0)):
            break
        z = calc_z(p)
        print("P(z <= %f) = %f"%(z, p))
    except:
        break

